/*
 * ExactNonlinearTreePatternAutomaton.h
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_NONLINEAR_TREE_PATTERN_AUTOMATON_H__
#define _EXACT_NONLINEAR_TREE_PATTERN_AUTOMATON_H__

#include <automaton/AutomatonFeatures.h>
#include <tree/TreeFeatures.h>
#include <core/multipleDispatch.hpp>
#include <alphabet/Symbol.h>
#include <alphabet/RankedSymbol.h>

#include <vector>

namespace arbology {

namespace exact {

class ExactNonlinearTreePatternAutomaton : public std::SingleDispatch < ExactNonlinearTreePatternAutomaton, automaton::Automaton, const tree::TreeBase &, const alphabet::Symbol &, const std::set < alphabet::Symbol > & > {
	static automaton::InputDrivenNPDA < > constructInternal ( const tree::PrefixRankedTree & tree, const alphabet::Symbol & subtreeWildcard, const alphabet::Symbol & currentNonlinearVariable, const std::set < alphabet::Symbol > & nonlinearVariables );

	static void constructTail ( automaton::InputDrivenNPDA < > & res, const tree::PrefixRankedTree & tree, const alphabet::Symbol & subtreeWildcard, const alphabet::Symbol & currentNonlinearVariable, const std::set < alphabet::Symbol > & nonlinearVariables, const alphabet::RankedSymbol & subtreeSettings, unsigned subtreeId, std::vector < alphabet::RankedSymbol >::const_iterator rankedSymbolsIter, int i, std::vector < alphabet::RankedSymbol >::const_iterator subtreeRepeatsIter );

public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct ( const tree::Tree & tree, const alphabet::Symbol & subtreeWildcard, const std::set < alphabet::Symbol > & nonlinearVariables );

	static automaton::InputDrivenNPDA < > construct ( const tree::PrefixRankedTree & tree, const alphabet::Symbol & subtreeWildcard, const std::set < alphabet::Symbol > & nonlinearVariables );
};

} /* namespace exact */

} /* namespace arbology */

#endif /* _EXACT_NONLINEAR_TREE_PATTERN_AUTOMATON_H__ */
